/*
idlj -fall Hello.idl
javac *.java HelloApp\*.java 
start orbd -ORBInitialPort 1050
java HelloWorldCorbaServer -ORBInitialPort 1050 -ORBInitialHost localhost
*/

import HelloApp.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;

import java.util.Properties;

class HelloImpl extends HelloPOA {
  private ORB orb;

  public void setORB(ORB orb_val) {
    orb = orb_val; 
  }
  
  public String sayHello() {
    return "Hello World";
  }
  
  public void shutdown() {
    orb.shutdown(false);
  }
}

public class HelloWorldCorbaServer {

  public static void main(String args[]) {
    try{

      ORB orb = ORB.init(args, null);

      POA rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
      rootpoa.the_POAManager().activate();

      HelloImpl helloImpl = new HelloImpl();
      helloImpl.setORB(orb); 

      org.omg.CORBA.Object ref = rootpoa.servant_to_reference(helloImpl);
      Hello href = HelloHelper.narrow(ref);
      
      org.omg.CORBA.Object objRef =
          orb.resolve_initial_references("NameService");
      NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);

      String name = "Hello";
      NameComponent path[] = ncRef.to_name( name );
      ncRef.rebind(path, href);

      System.out.println("HelloWorldCorbaServer run");

      orb.run();
    } catch (Exception e) {
      e.printStackTrace();
    }
    
    System.out.println("HelloWorldCorbaServer stop");
  }
}
